#include	"fsxgauges_sp2.h"

#include	"ITrafficInfo.h"
#include	"TrafficData.h"
#include	"GdiPlusRadar.h"
#include	"XMLCCallbacks.h"
#include	"tools.h"
#include	"resource.h"
#include	<stdio.h>
#include	<math.h>

#include	"tools.cpp"
#include	"GdiPlusRadar.cpp"
#include	"XMLCCallbacks.cpp"
#include	"TrafficData.cpp"

PPANELS Panels = NULL;

MyPanelCCallback	*my_pcc		=	NULL;
MyPanelCCallback	*myold_pcc	=	NULL;

void FSAPI module_init(void)
{
    if (NULL != Panels)
		{
		ImportTable.PANELSentry.fnptr = (PPANELS)Panels;
		}
	if(my_pcc==NULL)
		{
		my_pcc		=	new MyPanelCCallback();
		panel_register_c_callback(INTERFACE_NAME,my_pcc);
		}
	if(myold_pcc==NULL)
		{
		myold_pcc	=	new MyPanelCCallback(TRUE);
		panel_register_c_callback(OLDINTERFACE_NAME,myold_pcc);
		}
}

void FSAPI module_deinit(void)
{
	//release after usage
	SAFE_RELEASE(my_pcc);
	SAFE_RELEASE(myold_pcc);
	
	//possibly not necessary, but won't hurt either
	panel_register_c_callback(INTERFACE_NAME,NULL);
	panel_register_c_callback(OLDINTERFACE_NAME,NULL);
}

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
	//only a dummy now, but hDLL can be needed in more complex arrangements
	return TRUE;
}

/* This is the module's import table.	*/	\
GAUGESIMPORT	ImportTable =				\
	{										\
	{ 0x0000000F, (PPANELS)NULL },			\
	{ 0x00000000, NULL }					\
	};										\
											\
											\
/* This is the module's export table.	*/	\
GAUGESLINKAGE	Linkage =					\
	{										\
	0x000002d9,								\
	module_init,							\
	module_deinit,							\
	0,										\
	0,										\
	FS9LINK_VERSION, {0}
	};
